{    var   : }
{ ALF, BTA, A, B }
Unit QSJ2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQSJ2_p, QSJAC_p;

procedure QSJ2R(var RINT :Real; var A :Real; var B :Real;
                var ALF :Real; var BTA :Real; F :Func_F1;
                var NN :Integer; EPS :Real; var IERR :Integer);

implementation

procedure QSJ2R(var RINT :Real; var A :Real; var B :Real;
                var ALF :Real; var BTA :Real; F :Func_F1;
                var NN :Integer; EPS :Real; var IERR :Integer);
var
N,IF_,J :Integer;
SAB,DBA,FN,FN1,Q1,Q2,Q3,Q4,Q5,S1,S2,P,C :Real;
X :Array [0..511] of Real;
W :Array [0..511] of Real;
AC :Array [0..511] of Real;
BC :Array [0..511] of Real;
CC :Array [0..511] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
SAB := ALF+BTA;
DBA := ALF-BTA;
P := SAB*DBA;
AC[0] := 0.0;
BC[0] := 0.0;
CC[0] := 0.0;
for N:=2 to 512 do
 begin
  FN := N;
  FN1 := N-1;
  Q1 := 2.0*FN+SAB;
  Q2 := Q1-1.0;
  Q3 := SAB+FN;
  Q4 := FN*Q3;
  Q5 := Q4*(Q1-2.0);
  AC[N-1] := Q1*Q2/(2.0*Q4);
  BC[N-1] := P*Q2/(2.0*Q5);
  CC[N-1] := Q1*(ALF+FN1)*(BTA+FN1)/Q5;
_1:
 end;
N := NN;
IF_ := 1;
goto _4;
_2:
N := N+N;
if ( N-512 ) < 0
 then goto _4
 else if ( N-512 ) > 0
       then goto _3
       else goto _4;
_3:
IERR := 1;
NN := N div 2;
UTQSJ2;
goto _9;
_4:
QSJAC(X,W,ALF,BTA,N,A,B,C);
S2 := 0.0;
for J:=1 to N do
 begin
_5:
  S2 := S2+W[J-1]*F(0.5*((B-A)*X[J-1]+A+B));
 end;
if ( IF_ = 1 )
 then goto _6;
if ( Abs(S1-S2)-EPS ) < 0
 then goto _8
 else if ( Abs(S1-S2)-EPS ) > 0
       then goto _7
       else goto _8;
_6:
IF_ := 2;
_7:
S1 := S2;
goto _2;
_8:
IERR := 0;
NN := N;
_9:
RINT := S2;
end;

end.
